
interface str {
   type: "string";
   [k: string]: unknown;
}

interface num {
   type: "number";
   [k: string]: unknown;
}

interface obj {
   [k: string]: unknown;
}

type ManyTypes<
   T extends Record<string, unknown>,
   K extends keyof T = keyof T
> = {
   [P in K]: T[P] extends str
      ? string
      : T[P] extends num
      ? number
      : T[P] extends obj
      ? ManyTypes<T[P]>
      : unknown;
};

interface def {
   type?: "string" | "number";
   [k: string]: unknown;
}

function toMT<T extends Record<string, def>>(value: T): ManyTypes<T> {
   const out: Record<string, string | number | unknown> = {};
   for (const key in value) {
      if (value[key].type === "string") {
         out[key] = "a string";
      } else if (value[key].type === "number") {
         out[key] = 99;
      } else if (!("type" in value[key])) {
         out[key] = value[key];
      } else {
         out[key] = null;
      }
   }
   return out as ManyTypes<T>;
}

const f = toMT({
   name: {
      type: "string",
   },
   age: {
      type: "number",
   },
   sub: {
      prop: {
         type: "string",
      },
      prop2: {
         type: "number",
      },
   },
});

type MS = typeof f;
