import { expect } from "chai";
import { isObject } from "../src/util";

describe("isObject", function () {
   it("Should match {}", function () {
      expect(isObject({})).to.equal(true);
   });
   it("Should match Object.create(null)", function () {
      expect(isObject(Object.create(null))).to.equal(true);
   });
   it("Should not match any other values", function () {
      expect(isObject([])).to.equal(false);
      expect(isObject(new Set())).to.equal(false);
      expect(isObject(new Map())).to.equal(false);
      expect(isObject(new Date())).to.equal(false);
      expect(isObject(() => {})).to.equal(false);
      expect(isObject(/1/)).to.equal(false);
      expect(isObject("1")).to.equal(false);
      expect(isObject(1)).to.equal(false);
      expect(isObject(BigInt(1))).to.equal(false);
      expect(isObject(null)).to.equal(false);
      expect(isObject(undefined)).to.equal(false);
   });
});
